﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2023.1.2),
    on December 06, 2023, at 12:09
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

# --- Import packages ---
from psychopy import locale_setup
from psychopy import prefs
from psychopy import plugins
plugins.activatePlugins()
prefs.hardware['audioLib'] = 'ptb'
prefs.hardware['audioLatencyMode'] = '3'
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard

# Run 'Before Experiment' code from code
msg = ' '
# Run 'Before Experiment' code from codeYourResponse
msg2 = ' '


# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2023.1.2'
expName = 'time_generalization_00'  # from the Builder filename that created this script
expInfo = {
    'participant': f"{randint(0, 999999):06.0f}",
    'session': '001',
    'gender': '',
    'age': '',
}
# --- Show participant info dialog --
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\experimentalni psychologie\\psychopy\\time_gen_within\\time_gen_within01_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# --- Setup the Window ---
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowStencil=False,
    monitor='testMonitor', color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb',
    backgroundImage='', backgroundFit='none',
    blendMode='avg', useFBO=True, 
    units='height')
win.mouseVisible = False
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# --- Setup input devices ---
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# --- Initialize components for Routine "WelcomeScreen" ---
textWelcomeScreen = visual.TextStim(win=win, name='textWelcomeScreen',
    text='Welcome to the temporal generalization experiment.\n',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
text = visual.TextStim(win=win, name='text',
    text='The experiment is about to start.\n\nIt will take cca 25 minutes. Please follow the instructions on the screen.\n\nPress SPACEBAR to begin.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
keyWelcome = keyboard.Keyboard()

# --- Initialize components for Routine "experimentDescription" ---
textExperimentDescription = visual.TextStim(win=win, name='textExperimentDescription',
    text='In this experiment, two stimuli will be presented at each trial. You will be asked to judge, if they both had SAME or DIFFERENT duration. \n\nThe task will remain constant through all the trials. \n',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textExperimentDescriptionSpacebar = visual.TextStim(win=win, name='textExperimentDescriptionSpacebar',
    text='Press SPACEBAR to continue.',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respExperimentDescription = keyboard.Keyboard()

# --- Initialize components for Routine "experimentDescription3" ---
textExperimentDescription3 = visual.TextStim(win=win, name='textExperimentDescription3',
    text='Please put two fingers of your dominant hand on keys B and N and keep them ready throughout the trials. Use B to indicate the same length and N to indicate that the length of the two stimuli differed. \n\n',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textExperimentDescriptionSpacebar_3 = visual.TextStim(win=win, name='textExperimentDescriptionSpacebar_3',
    text='Please, restrain from using any form of counting to estimate the duration of stimuli. Just observe /listen/ and make your choice. \n\n10 practice trials lie ahead.\nPress SPACEBAR to proceed.',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respExperimentDescription_3 = keyboard.Keyboard()

# --- Initialize components for Routine "blank2s" ---
textBlank3s = visual.TextStim(win=win, name='textBlank3s',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "standardTraining" ---
polygonStandardTraining = visual.Rect(
    win=win, name='polygonStandardTraining',
    width=(0.5, 0.5)[0], height=(0.5, 0.5)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='grey', fillColor='grey',
    opacity=None, depth=0.0, interpolate=True)
textStandardTraining = visual.TextStim(win=win, name='textStandardTraining',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
sound_1 = sound.Sound('88', secs=1.0, stereo=True, hamming=True,
    name='sound_1')
sound_1.setVolume(1.0)
image = visual.ImageStim(
    win=win,
    name='image', 
    image='images/monkey_sad.png', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-3.0)

# --- Initialize components for Routine "trialTraining" ---
stimulusTraining = visual.Rect(
    win=win, name='stimulusTraining',
    width=(0.5, 0.5)[0], height=(0.5, 0.5)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)
textTrialBorNTraining = visual.TextStim(win=win, name='textTrialBorNTraining',
    text='Did the stimuli had same or different duration?\n\nPress B for SAME or N for DIFFERENT',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respBorN_Training = keyboard.Keyboard()
sound_2 = sound.Sound('88', secs=-1, stereo=True, hamming=True,
    name='sound_2')
sound_2.setVolume(1.0)
image_2 = visual.ImageStim(
    win=win,
    name='image_2', 
    image='images/monkey_sad.png', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-4.0)

# --- Initialize components for Routine "feedback" ---
textFeedback = visual.TextStim(win=win, name='textFeedback',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "SeriesOfBlocksDescription" ---
textBlocksDescription = visual.TextStim(win=win, name='textBlocksDescription',
    text='In total, 120 trials are ahead of you. After each 20 you will be asked to take a short break to rest a little. \n\nLet us proceed with the trials.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textExperimentDescriptionSpacebar_2 = visual.TextStim(win=win, name='textExperimentDescriptionSpacebar_2',
    text='Press SPACEBAR to continue.',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respExperimentDescription_2 = keyboard.Keyboard()

# --- Initialize components for Routine "blank2s" ---
textBlank3s = visual.TextStim(win=win, name='textBlank3s',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# --- Initialize components for Routine "pause" ---
text_2 = visual.TextStim(win=win, name='text_2',
    text='this is a break',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "standard" ---
polygonStandard = visual.Rect(
    win=win, name='polygonStandard',
    width=(0.5, 0.5)[0], height=(0.5, 0.5)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)
textStandard = visual.TextStim(win=win, name='textStandard',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "trial" ---
polygonBlackSquare = visual.Rect(
    win=win, name='polygonBlackSquare',
    width=(0.5, 0.5)[0], height=(0.5, 0.5)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)
textTrialBorN = visual.TextStim(win=win, name='textTrialBorN',
    text='Did the stimuli had same or different duration?\n\nPress B for SAME or N for DIFFERENT',
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
key_respBorN = keyboard.Keyboard()

# --- Initialize components for Routine "yourResponseScreen" ---
textYourResponse = visual.TextStim(win=win, name='textYourResponse',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# --- Initialize components for Routine "GoodbyeScreen" ---
textGoodbyeScreen = visual.TextStim(win=win, name='textGoodbyeScreen',
    text='Thanks for participating.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.Clock()  # to track time remaining of each (possibly non-slip) routine 

# --- Prepare to start Routine "WelcomeScreen" ---
continueRoutine = True
# update component parameters for each repeat
keyWelcome.keys = []
keyWelcome.rt = []
_keyWelcome_allKeys = []
# keep track of which components have finished
WelcomeScreenComponents = [textWelcomeScreen, text, keyWelcome]
for thisComponent in WelcomeScreenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "WelcomeScreen" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textWelcomeScreen* updates
    
    # if textWelcomeScreen is starting this frame...
    if textWelcomeScreen.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textWelcomeScreen.frameNStart = frameN  # exact frame index
        textWelcomeScreen.tStart = t  # local t and not account for scr refresh
        textWelcomeScreen.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textWelcomeScreen, 'tStartRefresh')  # time at next scr refresh
        # update status
        textWelcomeScreen.status = STARTED
        textWelcomeScreen.setAutoDraw(True)
    
    # if textWelcomeScreen is active this frame...
    if textWelcomeScreen.status == STARTED:
        # update params
        pass
    
    # if textWelcomeScreen is stopping this frame...
    if textWelcomeScreen.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > textWelcomeScreen.tStartRefresh + 3.0-frameTolerance:
            # keep track of stop time/frame for later
            textWelcomeScreen.tStop = t  # not accounting for scr refresh
            textWelcomeScreen.frameNStop = frameN  # exact frame index
            # update status
            textWelcomeScreen.status = FINISHED
            textWelcomeScreen.setAutoDraw(False)
    
    # *text* updates
    
    # if text is starting this frame...
    if text.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
        # keep track of start time/frame for later
        text.frameNStart = frameN  # exact frame index
        text.tStart = t  # local t and not account for scr refresh
        text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
        # update status
        text.status = STARTED
        text.setAutoDraw(True)
    
    # if text is active this frame...
    if text.status == STARTED:
        # update params
        pass
    
    # *keyWelcome* updates
    waitOnFlip = False
    
    # if keyWelcome is starting this frame...
    if keyWelcome.status == NOT_STARTED and tThisFlip >= 3-frameTolerance:
        # keep track of start time/frame for later
        keyWelcome.frameNStart = frameN  # exact frame index
        keyWelcome.tStart = t  # local t and not account for scr refresh
        keyWelcome.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(keyWelcome, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'keyWelcome.started')
        # update status
        keyWelcome.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(keyWelcome.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(keyWelcome.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if keyWelcome.status == STARTED and not waitOnFlip:
        theseKeys = keyWelcome.getKeys(keyList=['space'], waitRelease=False)
        _keyWelcome_allKeys.extend(theseKeys)
        if len(_keyWelcome_allKeys):
            keyWelcome.keys = _keyWelcome_allKeys[-1].name  # just the last key pressed
            keyWelcome.rt = _keyWelcome_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in WelcomeScreenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "WelcomeScreen" ---
for thisComponent in WelcomeScreenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if keyWelcome.keys in ['', [], None]:  # No response was made
    keyWelcome.keys = None
thisExp.addData('keyWelcome.keys',keyWelcome.keys)
if keyWelcome.keys != None:  # we had a response
    thisExp.addData('keyWelcome.rt', keyWelcome.rt)
thisExp.nextEntry()
# the Routine "WelcomeScreen" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "experimentDescription" ---
continueRoutine = True
# update component parameters for each repeat
key_respExperimentDescription.keys = []
key_respExperimentDescription.rt = []
_key_respExperimentDescription_allKeys = []
# keep track of which components have finished
experimentDescriptionComponents = [textExperimentDescription, textExperimentDescriptionSpacebar, key_respExperimentDescription]
for thisComponent in experimentDescriptionComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "experimentDescription" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textExperimentDescription* updates
    
    # if textExperimentDescription is starting this frame...
    if textExperimentDescription.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescription.frameNStart = frameN  # exact frame index
        textExperimentDescription.tStart = t  # local t and not account for scr refresh
        textExperimentDescription.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescription, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescription.started')
        # update status
        textExperimentDescription.status = STARTED
        textExperimentDescription.setAutoDraw(True)
    
    # if textExperimentDescription is active this frame...
    if textExperimentDescription.status == STARTED:
        # update params
        pass
    
    # *textExperimentDescriptionSpacebar* updates
    
    # if textExperimentDescriptionSpacebar is starting this frame...
    if textExperimentDescriptionSpacebar.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescriptionSpacebar.frameNStart = frameN  # exact frame index
        textExperimentDescriptionSpacebar.tStart = t  # local t and not account for scr refresh
        textExperimentDescriptionSpacebar.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescriptionSpacebar, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescriptionSpacebar.started')
        # update status
        textExperimentDescriptionSpacebar.status = STARTED
        textExperimentDescriptionSpacebar.setAutoDraw(True)
    
    # if textExperimentDescriptionSpacebar is active this frame...
    if textExperimentDescriptionSpacebar.status == STARTED:
        # update params
        pass
    
    # *key_respExperimentDescription* updates
    waitOnFlip = False
    
    # if key_respExperimentDescription is starting this frame...
    if key_respExperimentDescription.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        key_respExperimentDescription.frameNStart = frameN  # exact frame index
        key_respExperimentDescription.tStart = t  # local t and not account for scr refresh
        key_respExperimentDescription.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_respExperimentDescription, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_respExperimentDescription.started')
        # update status
        key_respExperimentDescription.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_respExperimentDescription.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_respExperimentDescription.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_respExperimentDescription.status == STARTED and not waitOnFlip:
        theseKeys = key_respExperimentDescription.getKeys(keyList=['space'], waitRelease=False)
        _key_respExperimentDescription_allKeys.extend(theseKeys)
        if len(_key_respExperimentDescription_allKeys):
            key_respExperimentDescription.keys = _key_respExperimentDescription_allKeys[-1].name  # just the last key pressed
            key_respExperimentDescription.rt = _key_respExperimentDescription_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in experimentDescriptionComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "experimentDescription" ---
for thisComponent in experimentDescriptionComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_respExperimentDescription.keys in ['', [], None]:  # No response was made
    key_respExperimentDescription.keys = None
thisExp.addData('key_respExperimentDescription.keys',key_respExperimentDescription.keys)
if key_respExperimentDescription.keys != None:  # we had a response
    thisExp.addData('key_respExperimentDescription.rt', key_respExperimentDescription.rt)
thisExp.nextEntry()
# the Routine "experimentDescription" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "experimentDescription3" ---
continueRoutine = True
# update component parameters for each repeat
key_respExperimentDescription_3.keys = []
key_respExperimentDescription_3.rt = []
_key_respExperimentDescription_3_allKeys = []
# keep track of which components have finished
experimentDescription3Components = [textExperimentDescription3, textExperimentDescriptionSpacebar_3, key_respExperimentDescription_3]
for thisComponent in experimentDescription3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "experimentDescription3" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textExperimentDescription3* updates
    
    # if textExperimentDescription3 is starting this frame...
    if textExperimentDescription3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescription3.frameNStart = frameN  # exact frame index
        textExperimentDescription3.tStart = t  # local t and not account for scr refresh
        textExperimentDescription3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescription3, 'tStartRefresh')  # time at next scr refresh
        # update status
        textExperimentDescription3.status = STARTED
        textExperimentDescription3.setAutoDraw(True)
    
    # if textExperimentDescription3 is active this frame...
    if textExperimentDescription3.status == STARTED:
        # update params
        pass
    
    # *textExperimentDescriptionSpacebar_3* updates
    
    # if textExperimentDescriptionSpacebar_3 is starting this frame...
    if textExperimentDescriptionSpacebar_3.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescriptionSpacebar_3.frameNStart = frameN  # exact frame index
        textExperimentDescriptionSpacebar_3.tStart = t  # local t and not account for scr refresh
        textExperimentDescriptionSpacebar_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescriptionSpacebar_3, 'tStartRefresh')  # time at next scr refresh
        # update status
        textExperimentDescriptionSpacebar_3.status = STARTED
        textExperimentDescriptionSpacebar_3.setAutoDraw(True)
    
    # if textExperimentDescriptionSpacebar_3 is active this frame...
    if textExperimentDescriptionSpacebar_3.status == STARTED:
        # update params
        pass
    
    # *key_respExperimentDescription_3* updates
    waitOnFlip = False
    
    # if key_respExperimentDescription_3 is starting this frame...
    if key_respExperimentDescription_3.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        key_respExperimentDescription_3.frameNStart = frameN  # exact frame index
        key_respExperimentDescription_3.tStart = t  # local t and not account for scr refresh
        key_respExperimentDescription_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_respExperimentDescription_3, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_respExperimentDescription_3.started')
        # update status
        key_respExperimentDescription_3.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_respExperimentDescription_3.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_respExperimentDescription_3.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_respExperimentDescription_3.status == STARTED and not waitOnFlip:
        theseKeys = key_respExperimentDescription_3.getKeys(keyList=['space'], waitRelease=False)
        _key_respExperimentDescription_3_allKeys.extend(theseKeys)
        if len(_key_respExperimentDescription_3_allKeys):
            key_respExperimentDescription_3.keys = _key_respExperimentDescription_3_allKeys[-1].name  # just the last key pressed
            key_respExperimentDescription_3.rt = _key_respExperimentDescription_3_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in experimentDescription3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "experimentDescription3" ---
for thisComponent in experimentDescription3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_respExperimentDescription_3.keys in ['', [], None]:  # No response was made
    key_respExperimentDescription_3.keys = None
thisExp.addData('key_respExperimentDescription_3.keys',key_respExperimentDescription_3.keys)
if key_respExperimentDescription_3.keys != None:  # we had a response
    thisExp.addData('key_respExperimentDescription_3.rt', key_respExperimentDescription_3.rt)
thisExp.nextEntry()
# the Routine "experimentDescription3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
training = data.TrialHandler(nReps=1.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('trainingBlock.xlsx'),
    seed=None, name='training')
thisExp.addLoop(training)  # add the loop to the experiment
thisTraining = training.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTraining.rgb)
if thisTraining != None:
    for paramName in thisTraining:
        exec('{} = thisTraining[paramName]'.format(paramName))

for thisTraining in training:
    currentLoop = training
    # abbreviate parameter names if possible (e.g. rgb = thisTraining.rgb)
    if thisTraining != None:
        for paramName in thisTraining:
            exec('{} = thisTraining[paramName]'.format(paramName))
    
    # --- Prepare to start Routine "blank2s" ---
    continueRoutine = True
    # update component parameters for each repeat
    # keep track of which components have finished
    blank2sComponents = [textBlank3s]
    for thisComponent in blank2sComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "blank2s" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 2.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textBlank3s* updates
        
        # if textBlank3s is starting this frame...
        if textBlank3s.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textBlank3s.frameNStart = frameN  # exact frame index
            textBlank3s.tStart = t  # local t and not account for scr refresh
            textBlank3s.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textBlank3s, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textBlank3s.started')
            # update status
            textBlank3s.status = STARTED
            textBlank3s.setAutoDraw(True)
        
        # if textBlank3s is active this frame...
        if textBlank3s.status == STARTED:
            # update params
            pass
        
        # if textBlank3s is stopping this frame...
        if textBlank3s.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textBlank3s.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                textBlank3s.tStop = t  # not accounting for scr refresh
                textBlank3s.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textBlank3s.stopped')
                # update status
                textBlank3s.status = FINISHED
                textBlank3s.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in blank2sComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "blank2s" ---
    for thisComponent in blank2sComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-2.000000)
    
    # --- Prepare to start Routine "standardTraining" ---
    continueRoutine = True
    # update component parameters for each repeat
    sound_1.setSound('88', secs=1.0, hamming=True)
    sound_1.setVolume(1.0, log=False)
    # keep track of which components have finished
    standardTrainingComponents = [polygonStandardTraining, textStandardTraining, sound_1, image]
    for thisComponent in standardTrainingComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "standardTraining" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 3.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *polygonStandardTraining* updates
        
        # if polygonStandardTraining is starting this frame...
        if polygonStandardTraining.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonStandardTraining.frameNStart = frameN  # exact frame index
            polygonStandardTraining.tStart = t  # local t and not account for scr refresh
            polygonStandardTraining.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonStandardTraining, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonStandardTraining.started')
            # update status
            polygonStandardTraining.status = STARTED
            polygonStandardTraining.setAutoDraw(True)
        
        # if polygonStandardTraining is active this frame...
        if polygonStandardTraining.status == STARTED:
            # update params
            pass
        
        # if polygonStandardTraining is stopping this frame...
        if polygonStandardTraining.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > polygonStandardTraining.tStartRefresh + 1-frameTolerance:
                # keep track of stop time/frame for later
                polygonStandardTraining.tStop = t  # not accounting for scr refresh
                polygonStandardTraining.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'polygonStandardTraining.stopped')
                # update status
                polygonStandardTraining.status = FINISHED
                polygonStandardTraining.setAutoDraw(False)
        
        # *textStandardTraining* updates
        
        # if textStandardTraining is starting this frame...
        if textStandardTraining.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
            # keep track of start time/frame for later
            textStandardTraining.frameNStart = frameN  # exact frame index
            textStandardTraining.tStart = t  # local t and not account for scr refresh
            textStandardTraining.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textStandardTraining, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textStandardTraining.started')
            # update status
            textStandardTraining.status = STARTED
            textStandardTraining.setAutoDraw(True)
        
        # if textStandardTraining is active this frame...
        if textStandardTraining.status == STARTED:
            # update params
            pass
        
        # if textStandardTraining is stopping this frame...
        if textStandardTraining.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textStandardTraining.tStartRefresh + 2.0-frameTolerance:
                # keep track of stop time/frame for later
                textStandardTraining.tStop = t  # not accounting for scr refresh
                textStandardTraining.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textStandardTraining.stopped')
                # update status
                textStandardTraining.status = FINISHED
                textStandardTraining.setAutoDraw(False)
        
        # if sound_1 is starting this frame...
        if sound_1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            sound_1.frameNStart = frameN  # exact frame index
            sound_1.tStart = t  # local t and not account for scr refresh
            sound_1.tStartRefresh = tThisFlipGlobal  # on global time
            # add timestamp to datafile
            thisExp.addData('sound_1.started', tThisFlipGlobal)
            # update status
            sound_1.status = STARTED
            sound_1.play(when=win)  # sync with win flip
        
        # if sound_1 is stopping this frame...
        if sound_1.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > sound_1.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                sound_1.tStop = t  # not accounting for scr refresh
                sound_1.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'sound_1.stopped')
                # update status
                sound_1.status = FINISHED
                sound_1.stop()
        # update sound_1 status according to whether it's playing
        if sound_1.isPlaying:
            sound_1.status = STARTED
        elif sound_1.isFinished:
            sound_1.status = FINISHED
        
        # *image* updates
        
        # if image is starting this frame...
        if image.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            image.frameNStart = frameN  # exact frame index
            image.tStart = t  # local t and not account for scr refresh
            image.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(image, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'image.started')
            # update status
            image.status = STARTED
            image.setAutoDraw(True)
        
        # if image is active this frame...
        if image.status == STARTED:
            # update params
            pass
        
        # if image is stopping this frame...
        if image.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > image.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                image.tStop = t  # not accounting for scr refresh
                image.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'image.stopped')
                # update status
                image.status = FINISHED
                image.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in standardTrainingComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "standardTraining" ---
    for thisComponent in standardTrainingComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    sound_1.stop()  # ensure sound has stopped at end of routine
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-3.000000)
    
    # --- Prepare to start Routine "trialTraining" ---
    continueRoutine = True
    # update component parameters for each repeat
    stimulusTraining.setFillColor('grey')
    stimulusTraining.setLineColor('grey')
    key_respBorN_Training.keys = []
    key_respBorN_Training.rt = []
    _key_respBorN_Training_allKeys = []
    sound_2.setSound('88', secs=duration, hamming=True)
    sound_2.setVolume(1.0, log=False)
    # keep track of which components have finished
    trialTrainingComponents = [stimulusTraining, textTrialBorNTraining, key_respBorN_Training, sound_2, image_2]
    for thisComponent in trialTrainingComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "trialTraining" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *stimulusTraining* updates
        
        # if stimulusTraining is starting this frame...
        if stimulusTraining.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            stimulusTraining.frameNStart = frameN  # exact frame index
            stimulusTraining.tStart = t  # local t and not account for scr refresh
            stimulusTraining.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(stimulusTraining, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'stimulusTraining.started')
            # update status
            stimulusTraining.status = STARTED
            stimulusTraining.setAutoDraw(True)
        
        # if stimulusTraining is active this frame...
        if stimulusTraining.status == STARTED:
            # update params
            pass
        
        # if stimulusTraining is stopping this frame...
        if stimulusTraining.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > stimulusTraining.tStartRefresh + duration-frameTolerance:
                # keep track of stop time/frame for later
                stimulusTraining.tStop = t  # not accounting for scr refresh
                stimulusTraining.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'stimulusTraining.stopped')
                # update status
                stimulusTraining.status = FINISHED
                stimulusTraining.setAutoDraw(False)
        
        # *textTrialBorNTraining* updates
        
        # if textTrialBorNTraining is starting this frame...
        if textTrialBorNTraining.status == NOT_STARTED and tThisFlip >= duration-frameTolerance:
            # keep track of start time/frame for later
            textTrialBorNTraining.frameNStart = frameN  # exact frame index
            textTrialBorNTraining.tStart = t  # local t and not account for scr refresh
            textTrialBorNTraining.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTrialBorNTraining, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textTrialBorNTraining.started')
            # update status
            textTrialBorNTraining.status = STARTED
            textTrialBorNTraining.setAutoDraw(True)
        
        # if textTrialBorNTraining is active this frame...
        if textTrialBorNTraining.status == STARTED:
            # update params
            pass
        
        # *key_respBorN_Training* updates
        waitOnFlip = False
        
        # if key_respBorN_Training is starting this frame...
        if key_respBorN_Training.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_respBorN_Training.frameNStart = frameN  # exact frame index
            key_respBorN_Training.tStart = t  # local t and not account for scr refresh
            key_respBorN_Training.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_respBorN_Training, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_respBorN_Training.started')
            # update status
            key_respBorN_Training.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_respBorN_Training.clock.reset)  # t=0 on next screen flip
        if key_respBorN_Training.status == STARTED and not waitOnFlip:
            theseKeys = key_respBorN_Training.getKeys(keyList=['b','n'], waitRelease=False)
            _key_respBorN_Training_allKeys.extend(theseKeys)
            if len(_key_respBorN_Training_allKeys):
                key_respBorN_Training.keys = _key_respBorN_Training_allKeys[0].name  # just the first key pressed
                key_respBorN_Training.rt = _key_respBorN_Training_allKeys[0].rt
                # was this correct?
                if (key_respBorN_Training.keys == str(corrAns)) or (key_respBorN_Training.keys == corrAns):
                    key_respBorN_Training.corr = 1
                else:
                    key_respBorN_Training.corr = 0
                # a response ends the routine
                continueRoutine = False
        
        # if sound_2 is starting this frame...
        if sound_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            sound_2.frameNStart = frameN  # exact frame index
            sound_2.tStart = t  # local t and not account for scr refresh
            sound_2.tStartRefresh = tThisFlipGlobal  # on global time
            # add timestamp to datafile
            thisExp.addData('sound_2.started', tThisFlipGlobal)
            # update status
            sound_2.status = STARTED
            sound_2.play(when=win)  # sync with win flip
        
        # if sound_2 is stopping this frame...
        if sound_2.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > sound_2.tStartRefresh + duration-frameTolerance:
                # keep track of stop time/frame for later
                sound_2.tStop = t  # not accounting for scr refresh
                sound_2.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'sound_2.stopped')
                # update status
                sound_2.status = FINISHED
                sound_2.stop()
        # update sound_2 status according to whether it's playing
        if sound_2.isPlaying:
            sound_2.status = STARTED
        elif sound_2.isFinished:
            sound_2.status = FINISHED
        
        # *image_2* updates
        
        # if image_2 is starting this frame...
        if image_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            image_2.frameNStart = frameN  # exact frame index
            image_2.tStart = t  # local t and not account for scr refresh
            image_2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(image_2, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'image_2.started')
            # update status
            image_2.status = STARTED
            image_2.setAutoDraw(True)
        
        # if image_2 is active this frame...
        if image_2.status == STARTED:
            # update params
            pass
        
        # if image_2 is stopping this frame...
        if image_2.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > image_2.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                image_2.tStop = t  # not accounting for scr refresh
                image_2.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'image_2.stopped')
                # update status
                image_2.status = FINISHED
                image_2.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialTrainingComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "trialTraining" ---
    for thisComponent in trialTrainingComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_respBorN_Training.keys in ['', [], None]:  # No response was made
        key_respBorN_Training.keys = None
        # was no response the correct answer?!
        if str(corrAns).lower() == 'none':
           key_respBorN_Training.corr = 1;  # correct non-response
        else:
           key_respBorN_Training.corr = 0;  # failed to respond (incorrectly)
    # store data for training (TrialHandler)
    training.addData('key_respBorN_Training.keys',key_respBorN_Training.keys)
    training.addData('key_respBorN_Training.corr', key_respBorN_Training.corr)
    if key_respBorN_Training.keys != None:  # we had a response
        training.addData('key_respBorN_Training.rt', key_respBorN_Training.rt)
    sound_2.stop()  # ensure sound has stopped at end of routine
    # the Routine "trialTraining" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # --- Prepare to start Routine "feedback" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code
    if key_respBorN_Training.corr:
        msg = 'Correct'
    else:
        msg = 'Uncorrect'    
    textFeedback.setText(msg)
    # keep track of which components have finished
    feedbackComponents = [textFeedback]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "feedback" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 1.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textFeedback* updates
        
        # if textFeedback is starting this frame...
        if textFeedback.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textFeedback.frameNStart = frameN  # exact frame index
            textFeedback.tStart = t  # local t and not account for scr refresh
            textFeedback.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textFeedback, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textFeedback.started')
            # update status
            textFeedback.status = STARTED
            textFeedback.setAutoDraw(True)
        
        # if textFeedback is active this frame...
        if textFeedback.status == STARTED:
            # update params
            pass
        
        # if textFeedback is stopping this frame...
        if textFeedback.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textFeedback.tStartRefresh + 1-frameTolerance:
                # keep track of stop time/frame for later
                textFeedback.tStop = t  # not accounting for scr refresh
                textFeedback.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textFeedback.stopped')
                # update status
                textFeedback.status = FINISHED
                textFeedback.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "feedback" ---
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-1.000000)
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'training'

# get names of stimulus parameters
if training.trialList in ([], [None], None):
    params = []
else:
    params = training.trialList[0].keys()
# save data for this loop
training.saveAsText(filename + 'training.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# --- Prepare to start Routine "SeriesOfBlocksDescription" ---
continueRoutine = True
# update component parameters for each repeat
key_respExperimentDescription_2.keys = []
key_respExperimentDescription_2.rt = []
_key_respExperimentDescription_2_allKeys = []
# keep track of which components have finished
SeriesOfBlocksDescriptionComponents = [textBlocksDescription, textExperimentDescriptionSpacebar_2, key_respExperimentDescription_2]
for thisComponent in SeriesOfBlocksDescriptionComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "SeriesOfBlocksDescription" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textBlocksDescription* updates
    
    # if textBlocksDescription is starting this frame...
    if textBlocksDescription.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textBlocksDescription.frameNStart = frameN  # exact frame index
        textBlocksDescription.tStart = t  # local t and not account for scr refresh
        textBlocksDescription.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textBlocksDescription, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textBlocksDescription.started')
        # update status
        textBlocksDescription.status = STARTED
        textBlocksDescription.setAutoDraw(True)
    
    # if textBlocksDescription is active this frame...
    if textBlocksDescription.status == STARTED:
        # update params
        pass
    
    # *textExperimentDescriptionSpacebar_2* updates
    
    # if textExperimentDescriptionSpacebar_2 is starting this frame...
    if textExperimentDescriptionSpacebar_2.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        textExperimentDescriptionSpacebar_2.frameNStart = frameN  # exact frame index
        textExperimentDescriptionSpacebar_2.tStart = t  # local t and not account for scr refresh
        textExperimentDescriptionSpacebar_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentDescriptionSpacebar_2, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textExperimentDescriptionSpacebar_2.started')
        # update status
        textExperimentDescriptionSpacebar_2.status = STARTED
        textExperimentDescriptionSpacebar_2.setAutoDraw(True)
    
    # if textExperimentDescriptionSpacebar_2 is active this frame...
    if textExperimentDescriptionSpacebar_2.status == STARTED:
        # update params
        pass
    
    # *key_respExperimentDescription_2* updates
    waitOnFlip = False
    
    # if key_respExperimentDescription_2 is starting this frame...
    if key_respExperimentDescription_2.status == NOT_STARTED and tThisFlip >= 6-frameTolerance:
        # keep track of start time/frame for later
        key_respExperimentDescription_2.frameNStart = frameN  # exact frame index
        key_respExperimentDescription_2.tStart = t  # local t and not account for scr refresh
        key_respExperimentDescription_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_respExperimentDescription_2, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'key_respExperimentDescription_2.started')
        # update status
        key_respExperimentDescription_2.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_respExperimentDescription_2.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_respExperimentDescription_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_respExperimentDescription_2.status == STARTED and not waitOnFlip:
        theseKeys = key_respExperimentDescription_2.getKeys(keyList=['space'], waitRelease=False)
        _key_respExperimentDescription_2_allKeys.extend(theseKeys)
        if len(_key_respExperimentDescription_2_allKeys):
            key_respExperimentDescription_2.keys = _key_respExperimentDescription_2_allKeys[-1].name  # just the last key pressed
            key_respExperimentDescription_2.rt = _key_respExperimentDescription_2_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in SeriesOfBlocksDescriptionComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "SeriesOfBlocksDescription" ---
for thisComponent in SeriesOfBlocksDescriptionComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_respExperimentDescription_2.keys in ['', [], None]:  # No response was made
    key_respExperimentDescription_2.keys = None
thisExp.addData('key_respExperimentDescription_2.keys',key_respExperimentDescription_2.keys)
if key_respExperimentDescription_2.keys != None:  # we had a response
    thisExp.addData('key_respExperimentDescription_2.rt', key_respExperimentDescription_2.rt)
thisExp.nextEntry()
# the Routine "SeriesOfBlocksDescription" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
Trials = data.TrialHandler(nReps=6.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('trialsWithin.xlsx'),
    seed=None, name='Trials')
thisExp.addLoop(Trials)  # add the loop to the experiment
thisTrial = Trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial:
        exec('{} = thisTrial[paramName]'.format(paramName))

for thisTrial in Trials:
    currentLoop = Trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    # --- Prepare to start Routine "blank2s" ---
    continueRoutine = True
    # update component parameters for each repeat
    # keep track of which components have finished
    blank2sComponents = [textBlank3s]
    for thisComponent in blank2sComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "blank2s" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 2.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textBlank3s* updates
        
        # if textBlank3s is starting this frame...
        if textBlank3s.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textBlank3s.frameNStart = frameN  # exact frame index
            textBlank3s.tStart = t  # local t and not account for scr refresh
            textBlank3s.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textBlank3s, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textBlank3s.started')
            # update status
            textBlank3s.status = STARTED
            textBlank3s.setAutoDraw(True)
        
        # if textBlank3s is active this frame...
        if textBlank3s.status == STARTED:
            # update params
            pass
        
        # if textBlank3s is stopping this frame...
        if textBlank3s.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textBlank3s.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                textBlank3s.tStop = t  # not accounting for scr refresh
                textBlank3s.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textBlank3s.stopped')
                # update status
                textBlank3s.status = FINISHED
                textBlank3s.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in blank2sComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "blank2s" ---
    for thisComponent in blank2sComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-2.000000)
    
    # --- Prepare to start Routine "pause" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code_2
    if Trials.thisN == 0 or Trials.thisN % 20 != 0:
        continueRoutine = False
    # keep track of which components have finished
    pauseComponents = [text_2]
    for thisComponent in pauseComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "pause" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 4.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_2* updates
        
        # if text_2 is starting this frame...
        if text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_2.frameNStart = frameN  # exact frame index
            text_2.tStart = t  # local t and not account for scr refresh
            text_2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_2, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'text_2.started')
            # update status
            text_2.status = STARTED
            text_2.setAutoDraw(True)
        
        # if text_2 is active this frame...
        if text_2.status == STARTED:
            # update params
            pass
        
        # if text_2 is stopping this frame...
        if text_2.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > text_2.tStartRefresh + 4-frameTolerance:
                # keep track of stop time/frame for later
                text_2.tStop = t  # not accounting for scr refresh
                text_2.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'text_2.stopped')
                # update status
                text_2.status = FINISHED
                text_2.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in pauseComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "pause" ---
    for thisComponent in pauseComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-4.000000)
    
    # --- Prepare to start Routine "standard" ---
    continueRoutine = True
    # update component parameters for each repeat
    polygonStandard.setFillColor(randColor)
    polygonStandard.setLineColor(randColor)
    # keep track of which components have finished
    standardComponents = [polygonStandard, textStandard]
    for thisComponent in standardComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "standard" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *polygonStandard* updates
        
        # if polygonStandard is starting this frame...
        if polygonStandard.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonStandard.frameNStart = frameN  # exact frame index
            polygonStandard.tStart = t  # local t and not account for scr refresh
            polygonStandard.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonStandard, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonStandard.started')
            # update status
            polygonStandard.status = STARTED
            polygonStandard.setAutoDraw(True)
        
        # if polygonStandard is active this frame...
        if polygonStandard.status == STARTED:
            # update params
            pass
        
        # if polygonStandard is stopping this frame...
        if polygonStandard.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > polygonStandard.tStartRefresh + standard-frameTolerance:
                # keep track of stop time/frame for later
                polygonStandard.tStop = t  # not accounting for scr refresh
                polygonStandard.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'polygonStandard.stopped')
                # update status
                polygonStandard.status = FINISHED
                polygonStandard.setAutoDraw(False)
        
        # *textStandard* updates
        
        # if textStandard is starting this frame...
        if textStandard.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
            # keep track of start time/frame for later
            textStandard.frameNStart = frameN  # exact frame index
            textStandard.tStart = t  # local t and not account for scr refresh
            textStandard.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textStandard, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textStandard.started')
            # update status
            textStandard.status = STARTED
            textStandard.setAutoDraw(True)
        
        # if textStandard is active this frame...
        if textStandard.status == STARTED:
            # update params
            pass
        
        # if textStandard is stopping this frame...
        if textStandard.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textStandard.tStartRefresh + 2.0-frameTolerance:
                # keep track of stop time/frame for later
                textStandard.tStop = t  # not accounting for scr refresh
                textStandard.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textStandard.stopped')
                # update status
                textStandard.status = FINISHED
                textStandard.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in standardComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "standard" ---
    for thisComponent in standardComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "standard" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # --- Prepare to start Routine "trial" ---
    continueRoutine = True
    # update component parameters for each repeat
    polygonBlackSquare.setFillColor(randColor)
    polygonBlackSquare.setLineColor(randColor)
    key_respBorN.keys = []
    key_respBorN.rt = []
    _key_respBorN_allKeys = []
    # keep track of which components have finished
    trialComponents = [polygonBlackSquare, textTrialBorN, key_respBorN]
    for thisComponent in trialComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "trial" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *polygonBlackSquare* updates
        
        # if polygonBlackSquare is starting this frame...
        if polygonBlackSquare.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonBlackSquare.frameNStart = frameN  # exact frame index
            polygonBlackSquare.tStart = t  # local t and not account for scr refresh
            polygonBlackSquare.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonBlackSquare, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonBlackSquare.started')
            # update status
            polygonBlackSquare.status = STARTED
            polygonBlackSquare.setAutoDraw(True)
        
        # if polygonBlackSquare is active this frame...
        if polygonBlackSquare.status == STARTED:
            # update params
            pass
        
        # if polygonBlackSquare is stopping this frame...
        if polygonBlackSquare.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > polygonBlackSquare.tStartRefresh + duration-frameTolerance:
                # keep track of stop time/frame for later
                polygonBlackSquare.tStop = t  # not accounting for scr refresh
                polygonBlackSquare.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'polygonBlackSquare.stopped')
                # update status
                polygonBlackSquare.status = FINISHED
                polygonBlackSquare.setAutoDraw(False)
        
        # *textTrialBorN* updates
        
        # if textTrialBorN is starting this frame...
        if textTrialBorN.status == NOT_STARTED and tThisFlip >= duration-frameTolerance:
            # keep track of start time/frame for later
            textTrialBorN.frameNStart = frameN  # exact frame index
            textTrialBorN.tStart = t  # local t and not account for scr refresh
            textTrialBorN.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTrialBorN, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textTrialBorN.started')
            # update status
            textTrialBorN.status = STARTED
            textTrialBorN.setAutoDraw(True)
        
        # if textTrialBorN is active this frame...
        if textTrialBorN.status == STARTED:
            # update params
            pass
        
        # *key_respBorN* updates
        waitOnFlip = False
        
        # if key_respBorN is starting this frame...
        if key_respBorN.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_respBorN.frameNStart = frameN  # exact frame index
            key_respBorN.tStart = t  # local t and not account for scr refresh
            key_respBorN.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_respBorN, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_respBorN.started')
            # update status
            key_respBorN.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_respBorN.clock.reset)  # t=0 on next screen flip
        if key_respBorN.status == STARTED and not waitOnFlip:
            theseKeys = key_respBorN.getKeys(keyList=['b','n'], waitRelease=False)
            _key_respBorN_allKeys.extend(theseKeys)
            if len(_key_respBorN_allKeys):
                key_respBorN.keys = _key_respBorN_allKeys[0].name  # just the first key pressed
                key_respBorN.rt = _key_respBorN_allKeys[0].rt
                # was this correct?
                if (key_respBorN.keys == str(corrAns)) or (key_respBorN.keys == corrAns):
                    key_respBorN.corr = 1
                else:
                    key_respBorN.corr = 0
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "trial" ---
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_respBorN.keys in ['', [], None]:  # No response was made
        key_respBorN.keys = None
        # was no response the correct answer?!
        if str(corrAns).lower() == 'none':
           key_respBorN.corr = 1;  # correct non-response
        else:
           key_respBorN.corr = 0;  # failed to respond (incorrectly)
    # store data for Trials (TrialHandler)
    Trials.addData('key_respBorN.keys',key_respBorN.keys)
    Trials.addData('key_respBorN.corr', key_respBorN.corr)
    if key_respBorN.keys != None:  # we had a response
        Trials.addData('key_respBorN.rt', key_respBorN.rt)
    # the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # --- Prepare to start Routine "yourResponseScreen" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from codeYourResponse
    if key_respBorN.keys == 'b':
        msg2 = 'You chose SAME'
    else:
        msg2 = 'You chose DIFFERENT'  
    textYourResponse.setText(msg2)
    # keep track of which components have finished
    yourResponseScreenComponents = [textYourResponse]
    for thisComponent in yourResponseScreenComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "yourResponseScreen" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 1.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textYourResponse* updates
        
        # if textYourResponse is starting this frame...
        if textYourResponse.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textYourResponse.frameNStart = frameN  # exact frame index
            textYourResponse.tStart = t  # local t and not account for scr refresh
            textYourResponse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textYourResponse, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textYourResponse.started')
            # update status
            textYourResponse.status = STARTED
            textYourResponse.setAutoDraw(True)
        
        # if textYourResponse is active this frame...
        if textYourResponse.status == STARTED:
            # update params
            pass
        
        # if textYourResponse is stopping this frame...
        if textYourResponse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > textYourResponse.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                textYourResponse.tStop = t  # not accounting for scr refresh
                textYourResponse.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'textYourResponse.stopped')
                # update status
                textYourResponse.status = FINISHED
                textYourResponse.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in yourResponseScreenComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "yourResponseScreen" ---
    for thisComponent in yourResponseScreenComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-1.000000)
    thisExp.nextEntry()
    
# completed 6.0 repeats of 'Trials'

# get names of stimulus parameters
if Trials.trialList in ([], [None], None):
    params = []
else:
    params = Trials.trialList[0].keys()
# save data for this loop
Trials.saveAsText(filename + 'Trials.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# --- Prepare to start Routine "GoodbyeScreen" ---
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
GoodbyeScreenComponents = [textGoodbyeScreen]
for thisComponent in GoodbyeScreenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "GoodbyeScreen" ---
routineForceEnded = not continueRoutine
while continueRoutine and routineTimer.getTime() < 3.0:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textGoodbyeScreen* updates
    
    # if textGoodbyeScreen is starting this frame...
    if textGoodbyeScreen.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textGoodbyeScreen.frameNStart = frameN  # exact frame index
        textGoodbyeScreen.tStart = t  # local t and not account for scr refresh
        textGoodbyeScreen.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textGoodbyeScreen, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'textGoodbyeScreen.started')
        # update status
        textGoodbyeScreen.status = STARTED
        textGoodbyeScreen.setAutoDraw(True)
    
    # if textGoodbyeScreen is active this frame...
    if textGoodbyeScreen.status == STARTED:
        # update params
        pass
    
    # if textGoodbyeScreen is stopping this frame...
    if textGoodbyeScreen.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > textGoodbyeScreen.tStartRefresh + 3.0-frameTolerance:
            # keep track of stop time/frame for later
            textGoodbyeScreen.tStop = t  # not accounting for scr refresh
            textGoodbyeScreen.frameNStop = frameN  # exact frame index
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textGoodbyeScreen.stopped')
            # update status
            textGoodbyeScreen.status = FINISHED
            textGoodbyeScreen.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in GoodbyeScreenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "GoodbyeScreen" ---
for thisComponent in GoodbyeScreenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
if routineForceEnded:
    routineTimer.reset()
else:
    routineTimer.addTime(-3.000000)

# --- End experiment ---
# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
